package cacciaAlTesoro;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

import org.json.simple.JSONObject;

public class CacciaTesoroClient implements Runnable {

	private Socket comunicazioneHttp;
	private GestioneCacciatori cacciatori;
	private long lunghezzaContenuto;

	public void setSocket(Socket s){
		comunicazioneHttp = s ;
	}

	public void setGestioneCacciatori(GestioneCacciatori gc){
		this.cacciatori = gc;
	}

	@Override
	public void run() {
		try{
			BufferedReader br = new BufferedReader(new InputStreamReader(comunicazioneHttp.getInputStream()));
			String[] testa = getIntestazione(br).split(" "); // GET /primaProva HTTP/1.0
			if(testa[0].equalsIgnoreCase("get") & testa[1].equals("/primaProva") & (testa[2].equalsIgnoreCase("http/1.1")|| testa[2].equalsIgnoreCase("http/1.0"))){
				if(isJavaClient(br)){
					BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(comunicazioneHttp.getOutputStream()));
					printResponseHeader(bw);
					BufferedReader br2 = new BufferedReader(new InputStreamReader(new FileInputStream("src/cacciaAlTesoro/PortScanner.java")));
					String linea = "";
					while((linea=br2.readLine())!=null){
						bw.write(linea+"\r\n");
						bw.flush();
					}
					br2.close();
					printIstruzioni(bw,"\r\n 1) Scarica il jar  http://reti.di.unimi.it/cacciaTesoro/cacciaTesoro.jar utilizzando un web browser.\r\n" +
							"2) Crea un progetto e importa il jar appena scaricato.\r\n"+
							"3) Crea una classe Test il cui main contiene le sequenti istruzioni:\r\n"+
							"\tPrimaProva p = new PrimaProva();\r\n"+
							"\tp.start(args);\r\n"+
							"4) Esegui la classe Test  passandogli il tuo numero di matricola\r\n"+
							"Il programma sta ascoltando su 4 porte TCP e ti visualizza 4 intervalli (uno per ogni porta) su cui cercare le porte aperte.\r\n"+
							"Completa il codice che ti ho inviato e cerca di riconoscere il numero delle 4 porte aperte.\r\n"+
							"La classe PortScanner prende come argomento due numeri corrispondenti agli estremi degli intervalli visualizzati dalla classe Test. Controlla un intervallo alla volta\r\n"+
							"Una volta trovate le porte aperte invia una richiesta HTTP alla risorsa /rispostaPrimaProva?matricola=tuaMatricola&porte=porta1+porta2+porta3+porta4\r\n");
					bw.close();
				}
				else{
					scriviImmagine(comunicazioneHttp.getOutputStream(),	new FileInputStream(new File("Cheat.gif")));
				}
			}
			if(testa[0].equalsIgnoreCase("get") & testa[1].startsWith("/rispostaPrimaProva?") & (testa[2].equalsIgnoreCase("http/1.1")| testa[2].equalsIgnoreCase("http/1.0"))){
				if(isJavaClient(br)){
					BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(comunicazioneHttp.getOutputStream()));
					printResponseHeader(bw);
					String[] keys = {"matricola","porte"};
					Map<String,String> parametri = ProcessaQuery.execute(testa[1],"/rispostaPrimaProva?",keys);
					if (parametri!=null & PortChecker.check(parametri.get("matricola"),parametri.get("porte"))){
						Cacciatore c = new Cacciatore(parametri.get("matricola"));
						cacciatori.add(c);
						printResponseHeader(bw);
						String token = c.generateToken();
						bw.write(token);
						bw.newLine();
						printIstruzioni(bw, "Brava/o!\r\n"+"Ora puoi inviare una richiesta HTTP di tipo GET alla risorsa /rispostaSecondaProva\r\n"+
						"passando l'argomento access_token con la stringa appena inviata\r\n. La risorsa, se richiesta in modo corretto, risponde con uno stream testuale in formato JSON");
						bw.flush();
						bw.close();
					}
					else{
						scriviImmagine(comunicazioneHttp.getOutputStream(), new FileInputStream(new File("Cheat.gif")));
					}
				}
			}
			if(testa[0].equalsIgnoreCase("get") & testa[1].startsWith("/rispostaSecondaProva?") & (testa[2].equalsIgnoreCase("http/1.1")| testa[2].equalsIgnoreCase("http/1.0"))){
				if(isJavaClient(br)){
					BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(comunicazioneHttp.getOutputStream()));
					printResponseHeader(bw);
					String[] keys = {"access_token"};
					Map<String,String> parametri = ProcessaQuery.execute(testa[1],"/rispostaSecondaProva?",keys);
					if(parametri != null){
						JSONObject root = new JSONObject();
						root.put("prossimaRisorsa","http://reti.di.unimi.it/form.html");
						root.put("incitazione","Mancano ancora due prove, la fine si avvicina");
						root.put("indicazioni", "Vai alla pagina indicata dal campo prossimaRisorsa usando il browser. Stai attento e' un form!!! Tutto quello che ti serve lo puoi trovare... Fai attenzione che la risposta consiste in un file in formato mp4!");
						root.put("commento","I cioccolatini sono  vicini ma i mastri cioccolatai della Lindt hanno pensato prove difficili");
						bw.write(root.toString());
						bw.flush();
						bw.close();
					}
				}else{
					scriviImmagine(comunicazioneHttp.getOutputStream(),new FileInputStream(new File("Cheat.gif")));
				}
			}
			if(testa[0].equalsIgnoreCase("post") & testa[1].equals("/rispostaTerzaProva") & (testa[2].equalsIgnoreCase("http/1.1")| testa[2].equalsIgnoreCase("http/1.0"))){
				if(isJavaClient(br)){
					BufferedOutputStream bos = new BufferedOutputStream(comunicazioneHttp.getOutputStream());
					char[] charBody = new char[(int)lunghezzaContenuto];
					br.read(charBody);
					String body = new String(charBody);
					String[] keys = {"domanda1","domanda2","domanda3","submit"};
					Map<String,String> parametri = ProcessaQuery.execute(body,"",keys);
					if(parametri != null){
						if(parametri.get("domanda1").equals("List") && parametri.get("domanda2").equals("ServerSocket") && parametri.get("domanda3").equals("true")){
							File response = new File("video000.mp4");
							long content_length = response.length();
							printResponseHeaderPost(bos,"video/mp4",content_length+"");
							scriviImmagine(bos, new FileInputStream(response));
							bos.close();
						}
					}
				}else{
					scriviImmagine(comunicazioneHttp.getOutputStream(),new FileInputStream(new File("Cheat.gif")));
				}
			}
			if(testa[0].equalsIgnoreCase("get") && testa[1].equalsIgnoreCase("/getProfToken") && (testa[2].equalsIgnoreCase("http/1.1")|| testa[2].equalsIgnoreCase("http/1.0"))){
				if(isJavaClient(br)){
					BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(comunicazioneHttp.getOutputStream()));
					printResponseHeader(bw);
					String tokenProf = (new Scanner(new File("token.txt"))).nextLine();
					String idPost = (new Scanner(new File("idPost.txt"))).nextLine();
					JSONObject root = new JSONObject();
					root.put("access_token", tokenProf);
					root.put("id",idPost);
					root.put("Indicazioni","Ultima prova!!! Usa l'access_token e l'id che ti ho inviato per fare una richiesta alle graph API. Devi commentare il post indicato dall'id scrivendo il tuo nome e cognome");
					root.put("Commento","Il primo che pubblica vince i cioccolatini");
					bw.write(root.toString());
					bw.flush();
					bw.close();
				}else{
					scriviImmagine(comunicazioneHttp.getOutputStream(),new FileInputStream(new File("Cheat.gif")));
				}
			}
		}catch(IOException ioe){
			System.out.println("errore nella lettura connessione");
		}
	}

	private void scriviImmagine(OutputStream os, InputStream is) throws IOException {
		byte[] buffer = new byte[100*1024];
		int letti = 0;
		while((letti=is.read(buffer))>=0){
			os.write(buffer, 0, letti);
			os.flush();
		}
		os.flush();
		os.close();
		is.close();
	}

	private String getIntestazione(BufferedReader br) throws IOException{
		return br.readLine();
	}

	private boolean isJavaClient(BufferedReader br) throws IOException{
		boolean response = false;
		String linea = "";
		while(!(linea = br.readLine()).equals("")){
			System.out.println(linea);
			String[] entryHeaderSplit = linea.split("\\:");
			if(entryHeaderSplit[0].equalsIgnoreCase("user-agent") && entryHeaderSplit[1].trim().startsWith("Java")){
				response = true;
			}
			if(entryHeaderSplit[0].equalsIgnoreCase("content-length")){
				lunghezzaContenuto = Long.parseLong(entryHeaderSplit[1].trim());
			}
		}
		return response;
	}
	

	private void printIstruzioni(BufferedWriter bw, String istruzioni) throws IOException{
		Scanner scan  = new Scanner(istruzioni);
		while(scan.hasNextLine()){
			try {
				Thread.sleep(2000);
			} catch (InterruptedException e) {
			}
			bw.write(scan.nextLine()+"\r\n");
			bw.flush();
		}

	}

	private void printResponseHeader(BufferedWriter bw) throws IOException{
		bw.write("HTTP/1.0 200 OK\r\n");
		bw.write("Content-Type: text/html; charset=UTF-8\r\n");
		bw.write("Server: GSE\r\n");
		bw.write("Connection: close\r\n");
		bw.write("\r\n");
		bw.flush();
	}

	private void printResponseHeaderPost(BufferedOutputStream bw,String content_type,String content_length) throws IOException{
		bw.write("HTTP/1.0 200 OK\r\n".getBytes());
		bw.write(("Content-Type: "+content_type+"\r\n").getBytes());
		bw.write(("Content-length: "+content_length).getBytes());
		bw.write(("Server: GSE\r\n").getBytes());
		bw.write("Connection: close\r\n".getBytes());
		bw.write("\r\n".getBytes());
		bw.flush();
	}
}
