package grafi;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.Socket;

import org.graphstream.graph.Edge;
import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.graph.implementations.SingleGraph;
import org.graphstream.stream.file.FileSource;
import org.graphstream.stream.file.FileSourceFactory;

public class ClientGrafo implements Runnable {

	private Socket canaleComunicazione;

	public void setSocket(Socket s){
		this.canaleComunicazione = s;
	}

	@Override
	public void run() {
		try{
			Graph g = new SingleGraph("");
			FileSource fs = FileSourceFactory.sourceFor("grafoClasse.dgs");
			fs.addSink(g);
			fs.readAll("grafoClasse.dgs");
			BufferedWriter bw = new BufferedWriter(
					new OutputStreamWriter(canaleComunicazione.getOutputStream()));
			for(Node n:g.getEachNode()){
				bw.write(n.getId()+" ");
			}
			bw.flush();
			bw.newLine(); //bw.write("\r\n");
			for(Edge e: g.getEachEdge()){
				bw.write(e.toString()+"\r\n");
			}
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
