package grafi;

import java.io.IOException;
import java.util.Iterator;

import org.graphstream.algorithm.Dijkstra;
import org.graphstream.algorithm.Toolkit;
import org.graphstream.graph.Edge;
import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.graph.implementations.SingleGraph;
import org.graphstream.stream.file.FileSource;
import org.graphstream.stream.file.FileSourceFactory;

public class TestGrafo{
	
	public static void main(String[] args) throws IOException {
		Graph g = new SingleGraph("Bellezza");
		//Inserimento nodi
		g.addNode("1");
		//g.addNode("1");  eccezione
		g.addNode("2");
		g.addNode("3");
		g.addNode("4");
		g.addNode("5");
		System.out.println(g.getNode("3"));
		//Inserimento archi
		g.addEdge("1-1", "1", "1");
		g.addEdge("1-4", "1", "4");
		//g.addEdge("1-5", "1", "4");
		g.addEdge("2->3", "2", "3",true);
		g.addEdge("3-4", "3", "4");
		g.addEdge("4-5", "4", "5");
		g.addEdge("2-5", "2", "5");
		System.out.println(g.getEdge("2->3"));
		//Il vicinato di un nodo
		Node nodo4 = g.getNode("4");
		Iterator<Node> iteratoriVicni = nodo4.getNeighborNodeIterator();
		while(iteratoriVicni.hasNext()){
			System.out.println(iteratoriVicni.next());
		}
		//Visualizzo grafo
		System.out.println(g);
		for(Node n: g.getEachNode()){
			System.out.print(n+" ");
		}
		System.out.println("");
		for(Edge e:g.getEachEdge()){
			System.out.println(e);
		}
		//Scrittura su file
		g.write("grafoClasse.dgs");
		//Lettura grafo
		Graph nuovo = new SingleGraph("");
		FileSource ferrovieDelloStato = FileSourceFactory.sourceFor("grafoClasse.dgs");
		ferrovieDelloStato.addSink(nuovo);
		ferrovieDelloStato.readAll("grafoClasse.dgs");
		nuovo.display();
		//Cammini minimi
		Dijkstra ds = new Dijkstra(Dijkstra.Element.EDGE, null, null);
		ds.init(nuovo);
		ds.setSource(nuovo.getNode("1"));
		ds.compute();
		for(Node n: nuovo.getEachNode()){
			System.out.println(ds.getSource() + "--->" + n + ":"
					+ ds.getPathLength(n));
		}
		
		
		//Grado di un nodo
		Node uno = nuovo.getNode("2");
		System.out.println(uno.getDegree());
		//Diametro
		System.out.println(Toolkit.diameter(nuovo));
		
		
		
		
		
		
		
		
		
		
		
		
		
	}
}