package http;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class AnalizzatoreUserAgent {

	public static void main(String[] args) {
		UserAgent ua = new UserAgent(); //ua mantiene una statistica degli user-agent utilizzati per connettersi
		ServerSocket s = null;
		try{
			int port = 7000; //Porta su cui ascolta il server nel caso args fosse vuoto
			if (args.length > 1){
				throw new IllegalArgumentException("numero parametri non corretto");
			}
			if (args.length == 1){
				port = Integer.parseInt(args[0]);
				if (port < 0){
					throw new IllegalArgumentException("porta non valida");
				}
			}
			s = new ServerSocket(port); //Creo una serverSocket di ascolto
			if(port == 0){
				System.out.println("Porta allocata: " + s.getLocalPort());
			}
			while (true){
				try{
					Socket data_socket = s.accept();
					(new Thread(new RequestProcessor(data_socket,ua))).start();
				}
				catch(IOException ioe){
					System.err.println("errore");
				}

			}

		}
		catch(Exception e){
			e.printStackTrace();
		}
		finally{
			try {
				if(s != null) s.close();
			} catch (IOException e) {}
		}
	}

}
