package http;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

public class EstrattoreImmaginiFromHtml {
	public static void main(String[] args) {
		try {
			String base = "http://www.google.it/search?q="; //URL per la risorsa ricerca di Google
			String query = URLEncoder.encode(args[0],"UTF-8"); //codifico la query
			System.out.println(base + query);
			URL u = new URL(base+query); //Oggetto URL che rappresenta la mia ricerca
			HttpURLConnection huc = (HttpURLConnection) u.openConnection();
			huc.addRequestProperty("host","www.google.it");
			huc.addRequestProperty("accept-encoding", "deflate");
			huc.addRequestProperty("accept-language", "sumero");
			//Modifico header della richiesta Http PRIMA di aprire la socket con il server di google
			//Lettura di una risposta Http di tipo stream di caratteri
			System.out.println(huc.getResponseCode());
			System.out.println(huc.getResponseMessage());
			
			BufferedReader br = new BufferedReader(new InputStreamReader(huc.getInputStream()));
			String response = "";
			String line = "";
			while((line=br.readLine())!=null){
				response += line+"\r\n";
			}
			br.close();
			//Al termine del while la stringa response conterr tutta la risposta => file in formato html
			response = response.substring(response.indexOf("<body")); //elimino la prte di HTML relativa all'header
			List<String> lista = estraiIMGTag(response); //Estraggo i link
			for(String s: lista){
				System.out.println(s);
			}			
		}catch(MalformedURLException mue){}
		catch(IOException ioe){}
	}
	
	private static List<String> estraiIMGTag(String risposta){
		List<String> listaLink = new ArrayList<>();
		String preambolo = "<img"; //i link che mi interessano sono i valori assegnati all'attributo href. Per esempio href="slide/lezione2.pdf"
		int c = 0; //Indice che si muove sulla 
		int inizio,fine;
		while (risposta.indexOf(preambolo,c)>=0){ //Finch trovo preambolo all'interno della stringa
			inizio = risposta.indexOf(preambolo,c)+preambolo.length(); //indice del primo carattere dopo href="
			fine = risposta.indexOf(">",inizio); //Indice della prima occorrenza del simbolo " =>fine dell'url del link
			System.out.println(risposta.substring(inizio, fine));
			listaLink.add(risposta.substring(inizio,fine)); //aggiungo url alla lista dei link trovati
			c = fine; //Sposta l'inizio della ricerca del preambolo dopo il termine dell'url trovato. 
		}
		return listaLink;
	}
}
