package http;

import java.util.List;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Date;
import java.util.Map;


/*
 * Questa classe restituisce l'header di una risposta HTTP utilizzando 3 diversi approcci
 * messi a disposizione dalla classe HttpURLConnection
 */
public class IspezioneHeaderRispostaHTTP {

	public static void main(String[] args) throws IOException {
		URL u = new URL("http://www.google.it"); //risorsa http specificata attraverso il suo URL 
		HttpURLConnection huc = (HttpURLConnection) u.openConnection(); //apro una connessione non ancora connessa
		huc.connect(); //creo una connessione => ora una socket tra mia applicazione e server esiste !!!
		System.out.println("--Ispezione header di risposta con metodi ad-hoc forniti da HttpURLConnection--");
		System.out.println("ContentLength:" + huc.getContentLength());
		System.out.println("ContentEncoding:" + huc.getContentEncoding());
		System.out.println("ContentType:" + huc.getContentType());
		System.out.println("Date: " + new Date(huc.getDate()));
		System.out.println("DateExpiration: " + new Date(huc.getExpiration()));
		System.out.println("DateLastModified: " + new Date(huc.getLastModified()));
		System.out.println("--Ispezione header di risposta con getHeaderField--");
		int count = 1;
		String key = huc.getHeaderFieldKey(count);
		while(key!=null){
			System.out.println(key + ":" + huc.getHeaderField(count));
			count++;
			key = huc.getHeaderFieldKey(count);
		}
		//Con mappa
		System.out.println("--con Mappa--");
		Map<String,List<String>> mappa = huc.getHeaderFields();
		for(String s: mappa.keySet()){
			System.out.println(s+":"+mappa.get(s).get(0));
		}
		
	}

	
}
