package http;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.Socket;


public class RequestProcessor implements Runnable {

	private Socket s;
	private UserAgent agents;

	public RequestProcessor(Socket request,UserAgent agent) {
		this.agents = agent;
		this.s = request;
	}

	public void run( ) {
		try {
			Writer out = new OutputStreamWriter(s.getOutputStream(),"ASCII"); //Stream di caratteri che server usa per inviare dati al client
			BufferedReader br = new BufferedReader(new InputStreamReader(s.getInputStream( ),"ASCII")); //Stream di caratteri per lettura richiesta client
			//Richiesta
			String get = br.readLine();
			System.out.println(get);
			String[] getElement = get.split(" ");
			String method = getElement[0];
			String protocol = getElement[2];
			if (method.equals("GET") && (protocol.equals("HTTP/1.0") || protocol.equals("HTTP/1.1") )) {
				try{
					while(!(get=br.readLine()).equals("")){//Finch leggo header
						if(get.toLowerCase().startsWith("user-agent")){ //Se header  relativo a user-agent
							String user = get.substring(get.indexOf(":")+1); //Estraggo il valore dello user-agent
							agents.addUserAgent(user.trim()); //Tolgo gli spazi
						}
					}
					out.write("GET corretto\r\n");
					out.flush();
				}catch(MalformedURLException mue){
					out.write("Richiesta non corretta\r\n");
					out.flush();
				}

			}
			else {
				out.write("Richiesta non accettata\r\n");
			}
		}
		catch (IOException ex) {
		}
		finally {
			try {
				s.close( );
			}
			catch (IOException ex) {}
		}
	}
}

