package serverHTTP;

import java.util.HashMap;
import java.util.Map;

import org.graphstream.graph.Graph;

public class AggiungiUtenteHandler implements ResourceHandler {

	private Map<String,String> queryMap;
	private Graph g;
	private String risposta;
	private boolean giusto;

	public AggiungiUtenteHandler(Graph g,String query){
		this.g=g;
		queryMap = new HashMap<String,String>();
		String[] elementQuery = query.split("&");
		for (int i = 0; i < elementQuery.length; i++) {
			String[] coppia = elementQuery[i].split("=");
			queryMap.put(coppia[0], coppia[1]);
		}
	}

	@Override
	public void gestisci() {
		if(queryMap.size()==1 && queryMap.containsKey("nomeUtente")){ //Controllo che i parametri corrispondano a quelli delle specifiche NB: CONTROLLO IMPORTANTE
			String nomeUtente = queryMap.get("nomeUtente"); //estraggo informazione dalla query
			g.addNode(nomeUtente); //gestisco la richiesta 
			risposta = nomeUtente;
			giusto = true;
		}else{
			risposta = "Errore nei parametri inviati";
			giusto = false;
		}
	}

	@Override
	public String getResponse() {
		return risposta;
	}

	@Override
	public boolean isCorrect() {
		return giusto;
	}

}
