package serverHTTP;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

import org.graphstream.graph.Graph;
import org.graphstream.graph.Node;
import org.graphstream.graph.implementations.SingleGraph;

public class CaricatoreGrafo {

	private Graph g;

	public CaricatoreGrafo(String fileName){
		g = new SingleGraph("socialPippo",false,true);
		try {
			Scanner scan = new Scanner(new File(fileName));
			while(scan.hasNextLine()){ //lettura riga per riga del file .txt
				String riga = scan.nextLine(); //nomeUtente-nomeUtente
				String[] idNodi = riga.split("-");
				g.addEdge(idNodi[0]+"--"+idNodi[1], idNodi[0], idNodi[1]); //creazione arco
			}
			scan.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public Graph getGraph(){
		return g;
	}
	
	public void decoraGrafo(String filename){
		try {
			Scanner scan = new Scanner(new File(filename));
			while(scan.hasNextLine()){
				String riga = scan.nextLine();
				String[] elementi = riga.split(",");
				Node n = g.getNode(elementi[0]); //prendo il nodo relativo all'utente i-esimo
				n.addAttribute("categoria",elementi[1]); //il metodo addAttribute permette di aggiungere un attributo ad un arco o ad un nodo.  Il valore assegnabile pu essere un qualsiasi oggetto Java
				if(elementi.length >2)
					n.addAttribute("categoria",elementi[2]);
				if(elementi.length >3)
					n.addAttribute("categoria", elementi[3]);	
			    System.out.println(n.getId()+":"+(String) n.getAttribute("categoria")); //il metodo getAttribute permette di prelevare il valore associato ad un attributo. Devo usare un cast perch il tipo restituito
			    //e' un generico Object !!!
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		CaricatoreGrafo cg = new CaricatoreGrafo("listaAmici.txt");
		cg.decoraGrafo("listaCategorie.txt");
		Graph g = cg.getGraph();
		g.display();
	}

}
