package serverHTTP;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;

/*
 * La classe Response modella una risposta HTTP. Mi permette di settare tutti gli elementi e di scriverla sull'outputStream
 */
public class Response {

	private String protocol;
	private String codice;
	private String message;
	private String response;

	public Response(String protocol, String codice, String message,
			String response) {
		super();
		this.protocol = protocol;
		this.codice = codice;
		this.message = message;
		this.response = response;
	}

	public void send(OutputStream os){
		try{
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(os));
			bw.write(protocol+" "+codice+" "+message+"\r\n");
			bw.write("connection: close\r\n");
			bw.write("content-type: text/html\r\n");
			bw.write("server: NPTLServer\r\n");
			bw.newLine();
			bw.flush();
			bw.write(response);
			bw.flush();
		}catch(IOException ioe){
			System.out.println("Errore nella scrtittura");
		}
	}

}
