package serverHTTP;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.MalformedURLException;
import java.net.Socket;
import java.net.URL;

import org.graphstream.graph.Graph;

public class ThreadHttpGet implements Runnable{

	private Socket channel;
	private Graph grafo;

	public void setSocket(Socket s){
		this.channel = s;
	}

	public void run() {
		InputStream is;
		OutputStream os;
		try {
			is = channel.getInputStream();
			Request richiestaClient = new Request(is); //Gestione della richiesta inviata dal client
			if(richiestaClient.isValid() && richiestaClient.getAccessMethod().equals("GET")){ //richiesta valida e di tipo GET
				try{
					URL u = new URL("file://"+richiestaClient.getUrl()); //Check automatico della sintassi
					String path = u.getPath(); //Estraggo  nome della risorsa chiamata senza parte relativa alla query
					String corpoRisposta = "";
					ResourceHandler rh = null;
					/*if(path.equals("/primaProva")){
						rh = new PrimaProvaHandler(u.getQuery());
						rh.gestisci();
					}*/
					/*
					 * Lo swtich gestisce le risorsa messe a disposizione del servizio. Se voglio inserire una nuova risorsa devo introdurre un nuovo case. Ogni risorsa  gestita da un oggetto
					 * che implementa la gestione di quella risorsa, incluso il controllo dei parametri passati come query
					 */
					switch (path) {
					case "/primaProva":
						rh = new PrimaProvaHandler(u.getQuery());
						rh.gestisci();
						break;
					case "/aggiungiUtente":
						rh = new AggiungiUtenteHandler(grafo,u.getQuery());
						rh.gestisci();
						break;
					}
					Response risposta = null;
					if(rh!=null){ //la risorsa richiesta esiste
						if(rh.isCorrect()){ //la gestione della risorsa non ha causato errori
							corpoRisposta = rh.getResponse();
							risposta = new Response("HTTP/1.0","200","OK",corpoRisposta);
						}else{
							corpoRisposta = rh.getResponse();
							risposta = new Response("HTTP/1.0","400","ERRORE",corpoRisposta);
						}
					}else{
						risposta = new Response("HTTP/1.0","400","ERRORE","Risorsa "+path+" non supportata");
					}
					os = channel.getOutputStream();
					risposta.send(os);
					os.close();
				}
				catch(MalformedURLException mue){ //Se l'url non  sintatticamente corretto lo comunico con un messaggio di errore al client
					os = channel.getOutputStream();
					Response rispostaErrore = new Response("HTTP/1.0","400","Errore","Errore nella sintassi della richiesta");
					rispostaErrore.send(os);
					os.close();
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	public void setGraph(Graph g) {
		this.grafo = g;
	}



}
