package servers;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.Socket;
import java.util.Scanner;

public class GestioneConnessioniFile implements GestioneConnessioni {
	
	private File fileLog;
	
	public GestioneConnessioniFile(String filename){
		fileLog = new File(filename);
	}

	@Override
	public synchronized boolean rimuoviSocket(Socket s) {
		try {
			Scanner scan = new Scanner (fileLog);
			String file = "";
			while(scan.hasNextLine()){
				String line = scan.nextLine();
				if(!line.equals(s.getRemoteSocketAddress().toString())){
					file+=line+"\r\n";
				}
			}
			scan.close();
			FileWriter fw = new FileWriter(fileLog);
			fw.write(file);
			fw.close();
			return true;
		} catch (FileNotFoundException e) {
			return false;
		} catch (IOException e) {
			return false;
		}
	}

	@Override
	public synchronized boolean addSocket(Socket s) {
		try {
			FileWriter fw = new FileWriter(fileLog,true);
			fw.write(s.getRemoteSocketAddress().toString()+"\r\n");
			fw.flush();
			fw.close();
			return true;
		} catch (IOException e) {
			return false;
		}
	}

	
	@Override
	public synchronized void clear() {
		fileLog.delete();
	}

}
