package servers;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.net.URL;

public class Login implements Runnable {

	private Socket scambio;
	private GestioneConnessioni gestore;
	private GestioneConnessioniSet utentiSocket;
	private Users utenti;

	public Login(Socket s){
		scambio = s;
		gestore = null;
	}

	public void setGestioneConnessioni(GestioneConnessioni gs, GestioneConnessioniSet gs2){
		gestore = gs;
		utentiSocket = gs2;
	}

	public void setUtenti(Users us){
		utenti = us;
	}

	@Override
	public void run() {
		try {
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(scambio.getOutputStream()));
			BufferedReader br = new BufferedReader(new InputStreamReader(scambio.getInputStream()));
			User u = null;
			gestore.addSocket(scambio);
			bw.write("Connessione gestita dal thread: "+Thread.currentThread().getName()+"\r\n");
			bw.flush();
			String line = "";
			while(!(line=br.readLine()).equals("q")){
				if(line.startsWith("login?")){
					System.out.println(line);
					String parts[] = line.substring(line.indexOf("?")+1).split("&");
					String email = (parts[0].split("="))[1];
					String password = (parts[1].split("="))[1];
					System.out.println(email + ":" + password);
					u = utenti.getUser(email);
					if(u != null && u.getPassword().equals(password)){ //Utente esiste e password  corretta
						if(u.isLogged()){ //Utente gi loggato
							String tcpAddress = utentiSocket.getSocket(u.getEmail()).getRemoteSocketAddress().toString();
							bw.write("utente gia loggato dall'indirizzo: "+tcpAddress+"\r\n");
						}
						else{
							u.setLogged(true);
							utentiSocket.addSocket(u.getEmail(),scambio);
							bw.write(u+"\r\n");
						}
						for(String nome:utentiSocket.getSocketSet()){
							bw.write(utentiSocket.getSocket(nome).getRemoteSocketAddress().toString()+"\r\n");
						}
						bw.flush();
					}
					else{
						bw.write("Utente inestistente o password sbagliata\r\n");
						bw.flush();
					}
				}
			}
			if(u !=null){
				utentiSocket.rimuoviSocket(u.getEmail());
			}
			gestore.rimuoviSocket(scambio);
			bw.close();
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
