package socket;

import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class IPClassi {
	
	public static void main(String[] args)  {
		try {
			//Uso di getByName
			InetAddress indirizzoIPGoogle = InetAddress.getByName("www.google.it");
			System.out.println("HostName: "+indirizzoIPGoogle.getHostName());
			System.out.println("Stringa dell'oggetto InetAddress: "+indirizzoIPGoogle);
			byte[] add = indirizzoIPGoogle.getAddress();
			System.out.print("IP da array di byte: ");
			for (int i = 0;  i < add.length; i++) {
				//Attenzione: in Java i byte sono signed quindi l'ultimo bit determina il segno
				int ui = (int)add[i] < 0 ? (int)add[i]+256 : (int)add[i];
				System.out.print(ui+".");
			}
			System.out.println("");
			//Uso di getAllByName
			System.out.println("IP associati a www.google.com: ");
			InetAddress[] indirizziIPGoogle = InetAddress.getAllByName("www.google.it");
			for (int i = 0; i < indirizziIPGoogle.length; i++) {
				System.out.println(i+") "+indirizziIPGoogle[i]);
			}
			//Uso di getLocalhost
			InetAddress localhost = InetAddress.getLocalHost();
			System.out.println("Localhost: "+localhost);
			//Uso getByAddress
			byte[] indirizzoIPLow = {(byte)173,(byte)194,(byte)44,(byte)31};
			InetAddress indirizzoDaGoogle = InetAddress.getByAddress(indirizzoIPLow);
			System.out.println("IP da array di byte: "+indirizzoDaGoogle);
			System.out.println("Reverse DNS: "+indirizzoDaGoogle.getHostName());
			//IsReachable
			System.out.println("E' raggiungibile: "+indirizzoDaGoogle.isReachable(5));
			//Uguaglianza tra IPs
			InetAddress a1 = InetAddress.getByName("www.ibiblio.org");
			InetAddress a2 = InetAddress.getByName("helios.metalab.unc.edu");
			if(a1.equals(a2)){
				System.out.println("Stesso InetAddress");
			}
			else{
				System.out.println("InetAddress diverso");
			}
		} catch ( IOException e) {
			e.printStackTrace();
		}
	}

}
