package thread;

public class DeadlockEsempio {

	static class Amico {
        private final String nome;
        
        public Amico(String nome) {
            this.nome = nome;
        }
        public String getNome() {
            return this.nome;
        }
        public synchronized void inchino(Amico altro) {
            System.out.format("%s: %s" + "  si inchinato verso di me!%n", this.nome, altro.getNome());
            altro.restituisciInchino(this);
        }
        public synchronized void restituisciInchino(Amico bower) {
            System.out.format("%s: %s"+ " mi ha restituito l'inchino!%n",this.nome, bower.getNome());
        }
    }

    public static void main(String[] args) throws InterruptedException {
        final Amico agamennone = new Amico("Agamennone");
        final Amico menelao = new Amico("Menelao");
        new Thread(new Runnable() {
            public void run() { agamennone.inchino(menelao); }
        }).start();
        //Thread.sleep(300);
        new Thread(new Runnable() {
            public void run() { menelao.inchino(agamennone); }
        }).start();
    }

}
