package url;

import java.net.MalformedURLException;
import java.net.URL;

public class UrlEsempi {

	public static void main(String[] args) {
		System.out.println("TEST dei PROTOCOLLI");
		// http
		testProtocol("http://www.adc.org");
		// https
		testProtocol("https://www.amazon.com/exec/obidos/order2/");
		// ftp
		testProtocol("ftp://metalab.unc.edu/pub/languages/java/javafaq/");
		// smtp
		testProtocol("mailto:elharo@metalab.unc.edu");
		// telnet
		testProtocol("telnet://dibner.poly.edu/");
		// local file access
		testProtocol("file:///etc/passwd");
		// gopher
		testProtocol("gopher://gopher.anc.org.za/");
		// Lightweight Directory Access Protocol
		testProtocol(
				"ldap://ldap.itd.umich.edu/o=University%20of%20Michigan,c=US?postalAddress");
		// JAR
		testProtocol(
				"jar:http://cafeaulait.org/books/javaio/ioexamples/javaio.jar!"
						+"/com/macfaq/io/StreamCopier.class");
		// NFS
		testProtocol("nfs://utopia.poly.edu/usr/tmp/");
		// jdbc
		testProtocol("jdbc:mysql://luna.metalab.unc.edu:3306/NEWS");
		// rmi
		testProtocol("rmi://metalab.unc.edu/RenderEngine");
		// 
		testProtocol("doc:/UsersGuide/release.html");
		testProtocol("netdoc:/UsersGuide/release.html");
		testProtocol("systemresource://www.adc.org/+/index.html");
		testProtocol("verbatim:http://www.adc.org/");
		System.out.println("COSTRUZIONE DI URL");
		
		URL u1;
		try {
			u1 = new URL("http://reti.di.unimi.it/codice/lezione1.zip");
			URL u2 = new URL(u1,"lezione2.zip");
			System.out.println(u2);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		System.out.println("PARTI DI UN URL");
		for (int i = 0; i < args.length; i++) {
			try {
				URL u = new URL(args[i]);
				System.out.println("URL: " + u);
				System.out.println("Schema: " + u.getProtocol( ));
				System.out.println("User info: " + u.getUserInfo( ));
				String host = u.getHost( );
				if (host != null) {
					int atSign = host.indexOf('@');
					if (atSign != -1) host = host.substring(atSign+1);
					System.out.println("Host: " + host);
				}
				else {
					System.out.println("Host null.");
				}
				System.out.println("Porta: " + u.getPort( ));
				System.out.println("Percorso: " + u.getPath( ));
				System.out.println("Frammento: " + u.getRef( ));
				System.out.println("Query: " + u.getQuery( ));
			}
			catch (MalformedURLException ex) {
				System.err.println(args[i] + " non  un URL valido.");
			}
			System.out.println( );
		}

		
	}
	
	/*
	 * Il metodo testProtocol controlla se un protocollo  supportato dalla JVM
	 */
	private static void testProtocol(String url) {
		try {
			URL u = new URL(url); //Se il costruttore non supporta
			System.out.println(u.getProtocol( ) + " supportato"); 
		}
		catch (MalformedURLException ex) {
			String protocol = url.substring(0, url.indexOf(':'));
			System.out.println(protocol + " non supportato");
		}
	}
}

