package xmlJson;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

public class CreazioneJSONFile {


	/*Creo un documento in formato JSON che contiene alcune informazioni relative ad una personsa quali: Nome, Cognome, stato civile
	 * ed email. Il campo email pu contenere pi elementi di tipo stinga quindi viene modellato come un array JSON
	 */
	public static void main(String[] args) {
		JSONObject radice = new JSONObject(); //creo un oggetto JSON per ora vuota che rappresenta la radice del mio documento
		radice.put("Nome", "Mario"); //L'inserimento di un valore si esegue attraverso il metodo put
		radice.put("Cognome","Rossi");
		radice.put("Stato civile","sposato");
		JSONArray emails = new JSONArray(); // in questo array (lista in Java) inserisco le email associate a Mario Rossi;
		emails.add("mario.rossi@alice.it");
		emails.add("mario.rossi@gmail.com");
		radice.put("email",emails); //Inserisco i valori delle mail nell'oggetto radice
		//Prima soluzione per scrivere un formato JSON su file
		try{
			FileWriter fw = new FileWriter(new File("personaJSON.txt")); //Uso FileWriter per scrivere un file testuale
			fw.write(radice+"\r\n");
			fw.close();
		}catch(IOException ioe){}
		
		//Seconda Soluzione
		try {
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("personaJSON2.txt"))); //Innesto costruttori per promuovere uno stream di byte verso file in uno stream di caratteri bufferizzato
			bw.write(radice+"\r\n");
			bw.flush(); //Ripulisco il buffer
			bw.close();
		} catch (IOException e) {
		}
	}

}
