package xmlJson;

import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import utili.Autore;
import utili.Libreria;
import utili.Libro;

public class daXMLaLibroDOM {
	
	/*
	 * Soluzione dell'esercizio 3 della lezione XML/JSON
	 */

	public static void main(String[] args) throws Exception {
		
		//Queste quattro linee di codice rappresentano una sequenza di istruzioni standard e di base per poter analizzare e parsare un file XML applicando DOM
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance(); //Primo passo per analizzare XML con approccio DOM
		DocumentBuilder docBuilder = factory.newDocumentBuilder(); //Oggetto DocumentBuilder
		File file = new File("bookStore.xml");
		Document doc = docBuilder.parse(file); //Il metodo parse restituisce un oggetto Document che rappresenta la radice del documento XML

		//Creazione Libreria
		Libreria library = new Libreria();
		
		//Tutti elementi <book> 
		NodeList bookNodes = doc.getElementsByTagName("book"); //Mi faccio restituire tutti gli elementi indicati dal tag <book>, ottenendo una lista di nodi <book>
		for (int i = 0; i < bookNodes.getLength(); i++) { //Per ogni elemento/nodo <book>
			Element bookElement = (Element)bookNodes.item(i); // <book>
			Libro l = new Libro(); //Creo un libro vuoto, per ora non ho informazioni da inserire
			String isbn = bookElement.getAttribute("ISBN"); // estraggo l'attributo ISBN
			l.setIsbn(isbn); //Setto ISBN

			// Figlio <title> di <book>
			NodeList titleNodes = bookElement.getElementsByTagName("title"); //mi faccio restituire i tag <title> relativi all'elemento <book>
			Element titleElement = (Element)titleNodes.item(0); //Nel DTD un libro deve avere uno e un solo titolo. 
			String titolo =  titleElement.getTextContent();
			l.setTitolo(titolo);

			// Figli <author> di <book>
			NodeList authorNodes = bookElement.getElementsByTagName("author"); //mi faccio restituire i tag <author> relativi all'elemento <book>
			for (int autoreIndice = 0; autoreIndice < authorNodes.getLength(); autoreIndice++) { //ciclo sugli autori del libro
				Element authorElement = (Element)authorNodes.item(autoreIndice); 
				String[] autoreInfo = authorElement.getTextContent().split(" ");
				String nome = autoreInfo[0];
				String cognome = autoreInfo[autoreInfo.length-1];
				Autore a = new Autore();
				a.setNome(nome);
				a.setCognome(cognome);
				l.setAutori(a);
			}
			library.addLibro(l.getIsbn(), l);
		}
		System.out.println(library);
	}
}

