package http;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

/*
 * Questa classe riceve in input l'url di un file da scaricare e lo salva in locale.
 */

public class DownloadFile {

	public static void main(String[] args) {
		try {
			URL u = new URL(args[0]); //args[0] deve essere un URL valido che indica quale file voglio scaricare
			HttpURLConnection huc = (HttpURLConnection) u.openConnection(); //apertura connessione senza creazione 
			InputStream is = huc.getInputStream(); //
			int length = huc.getContentLength(); //Dal momento che il server mi invia un file binario, molto probabilmente l'header di risposta
			//conterr il campo Content-length che mi indica quanti byte occupa la risorsa richiesta.
			String filename = u.getFile().substring(u.getFile().lastIndexOf("/")+1); //Nome del file da salvare
			FileOutputStream fos = new FileOutputStream(filename); //Stream byte di scrittura su file
			if(length!=-1){ //Content-lenght settato -> se il campo non  getContentLength mi restituisce -1
				byte[] bufferFile = new byte[length]; //buffer di lettura dallo stream di input = risposta Http
				int offset = 0;
				int byteLetti = 0; //numero di byte letti ad ogni iterazione nel prossimo ciclo while
				//Al termine del ciclo while l'array bufferFile sar pieno di byte letti
				while(offset < length){ //Finch non raggiungo il limite di byte che il server mi deve inviare
					byteLetti = is.read(bufferFile,offset,bufferFile.length-offset); //metto i byte letti in questa iterazione nel posto giusto del buffer
					if(byteLetti==-1) break; //Durante la lettura  successo un evento inatteso e lo stream si  interrotto => finisco di leggere
					offset +=byteLetti; //Sposto indice a partire da quale inserisco i prossimi byte letti
				}
				is.close();
				if(offset != length){ //Il server mi ha mentito sulla dimensione della risposta
					throw new IOException("Numero di byte letti non corretto");
				}
				fos.write(bufferFile); //Scrivo il contenuto della risposta nel file
				fos.flush();
				fos.close();
			}
			else{ //Content-length non settato
				byte[] buffer = new byte[512];
				int letti=0;
				while((letti=is.read(buffer))!=-1){ //Solito metodo di scrittura fino alla chiusura dello stream da parte del server
					fos.write(buffer, 0, letti);
					fos.flush();
				}
				is.close();
			}
			fos.close();
			
		} catch (MalformedURLException e) {
			System.out.println("URL malformato");
		} catch (IOException e) {
			System.out.println("Errore nella connessione");
		}
	}
}
