package servers;

import java.net.Socket;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class GestioneConnessioniSet implements GestioneConnessioni{

	private Map<String,Socket> connessioniAperte;
	
	public GestioneConnessioniSet(){
		connessioniAperte = new HashMap<String,Socket>();
	}
	
	@Override
	public synchronized boolean addSocket(Socket s) {
		 if (connessioniAperte.put(s.getRemoteSocketAddress().toString(),s) != null)
			 return true;
		 else
			 return false; 
	}

	@Override
	public synchronized boolean rimuoviSocket(Socket s) {
		if(connessioniAperte.remove(s.getRemoteSocketAddress().toString())!=null)
			return true;
		else
			return false;
	}
	
	public synchronized Set<String> getSocketSet(){
		return connessioniAperte.keySet();
	}
	
	public synchronized Socket getSocket(String socketName){
		return connessioniAperte.get(socketName);
	}

	@Override
	public synchronized void clear() {
		connessioniAperte.clear();
	}
	
	public synchronized boolean addSocket(String key,Socket s){
		 if (connessioniAperte.put(key,s) != null)
			 return true;
		 else
			 return false; 
	}
	
	public synchronized boolean rimuoviSocket(String key){
		if(connessioniAperte.remove(key)!=null)
			return true;
		else
			return false;
	}
}