package url;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;


/*
 * Applicazione della classe URLEncoder a stringhe contenenti caratteri che devono necessitano di escape
 */
public class EncodingUrl {

	public static void main(String[] args) {
		try{
			System.out.println(URLEncoder.encode("Stringa con spazi", "UTF-8"));
			System.out.println(URLEncoder.encode("Stringa*con*asterischi", "UTF-8"));
			System.out.println(URLEncoder.encode("Stringa%con%percentuali","UTF-8"));
			System.out.println(URLEncoder.encode("Stringa+con+pi", "UTF-8"));
			System.out.println(URLEncoder.encode("Stringa/con/slashes", "UTF-8"));
			System.out.println(URLEncoder.encode("Stringa\"con\"doppi\"apici","UTF-8"));
			System.out.println(URLEncoder.encode("Stringa:con:due:punti", "UTF-8"));
			System.out.println(URLEncoder.encode("Stringa~con~tilde", "UTF-8"));
			System.out.println(URLEncoder.encode("(Stringa)con(parentesi)","UTF-8"));
			System.out.println(URLEncoder.encode("Stringa.con.punto","UTF-8"));
			System.out.println(URLEncoder.encode("Stringa=con=uguale","UTF-8"));
			System.out.println(URLEncoder.encode("Stringa&con&ampersands", "UTF-8"));
			System.out.println(URLEncoder.encode("QuestastringanonhacaratteriASCII","UTF-8"));
			//In questa ultima parte si confrontano due approcci per codificare la query in un URL
			//1. Codifico tutta la query
			String query = URLEncoder.encode("pg=q&kl=XX&stype=stext&q=+\"Java+I/O\"&search.x=38&search.y=3");
			System.out.println(query);
			//2. Codifico solo le stringhe dei parametri  e dei valori tralasciando & = 
			query = URLEncoder.encode("pg");
			query += "=";
			query += URLEncoder.encode("q");
			query += "&";
			query += URLEncoder.encode("kl");
			query += "=";
			query += URLEncoder.encode("XX");
			query += "&";
			query += URLEncoder.encode("stype");
			query += "=";
			query += URLEncoder.encode("stext");
			query += "&";
			query += URLEncoder.encode("q");
			query += "=";
			query += URLEncoder.encode("\"Java I/O\"");
			query += "&";
			query += URLEncoder.encode("search.x");
			query += "=";
			query += URLEncoder.encode("38");
			query += "&";
			query += URLEncoder.encode("search.y");
			query += "=";
			query += URLEncoder.encode("3");
			System.out.println(query);
		}
		catch (UnsupportedEncodingException ex) {
			throw new RuntimeException("La Virtual Machine non supporta UTF-8");
		}

	}
}
